void videoStart() 
{
  //Verfügbare Kameras suchen und ausgeben
  String[] cameras = Capture.list();
  if (cameras.length == 0)   
  {
    println("There are no cameras available for capture.");
    exit();
  } else {
    println("Available cameras:");
    for (int i = 0; i < cameras.length; i++) 
    {
      println(i + " " + cameras[i]);
    }
    //Kamera initialisieren
    video = new Capture(this, 640, 480, kameraName, 30);

    //Kameraaufnahme starten
    video.start(); 

    numPixels = video.width * video.height; //Anzahl der Pixel des Kamerabildes berechnen
    println(numPixels);
  }
}

void Bildfaerbung() 
{
  //Kamerbild und Pixel lesen
  video.read();
  video.loadPixels();
  float pixelBrightness;
  loadPixels();

  //Variablen initialisieren
  int currPos = 0;
  color tempPixel;
  int rotxmax = 0;
  int rotxmin = wide;
  int rotymax = 0;
  int rotymin = high;

  int blauxmax = 0;
  int blauxmin = wide;
  int blauymax = 0;
  int blauymin = high;

  for (int y = 1; y <= 480; y++) //Y-Achse des Bildes durchgehen (Zeilenweise)
  {
    for (int x = 1; x <= 640; x++) //X-Achse des Bildes durchgehen (Spaltenweise)
    {   
      currPos = ((y-1) * wide) + (x-1); //von x,y-Koordinaten in Array-Position umrechnen
      pixelBrightness = brightness(video.pixels[currPos]); //Helligkeit des Pixels speichern
      tempPixel = video.pixels[currPos];

      //int pixelColor = video.pixels[currPos];
      int r = (tempPixel >> 16) & 0xff; //Rotanteil des Pixels bestimmen
      int g = (tempPixel >> 8) & 0xff; //Grünanteil des Pixels bestimmen
      int b = tempPixel & 0xff; //Blauanteil des Pixels bestimmen

      if (r > 1.7*g && r > 1.7*b && r>50) //Wenn Rotanteil überwiegt...
      {
        pixels[currPos] = color(255, 20, 20); //...Pixel rot färben

        //Ersten und letzten rote Pixel bestimmen, sowhl auf der x-Achse, als auch auf der y-Achse
        if (x < rotxmin) 
          rotxmin = x;
        else if (x > rotxmax) 
          rotxmax = x;
        if (y < rotymin) 
          rotymin = y;
        else if (y > rotymax)
          rotymax = y;
      }
      /* else if(g > 1.5*r && g > 1.5*b && g>20)
       pixels[currPos] = color(0, 255, 0);*/

      else if (b > 1.7*r && b > 1.7*g && b>50) { //Wenn Blauanteil überwiegt...

        pixels[currPos] = color(0, 0, 255); //...Pixel blau färben

        //Ersten und letzten blauen Pixel bestimmen, sowhl auf der x-Achse, als auch auf der y-Achse
        if (x<blauxmin) blauxmin = x;
        else if (x>blauxmax) blauxmax = x;
        if (y<blauymin) blauymin = y;
        else if (y>blauymax) blauymax = y;
      } 
      else if (pixelBrightness > threshold) { //Wenn Pixel heller als der Grenzwert ist...
        pixels[currPos] = white; //...Pixel weiß färben
      } else { //Ansonsten...
        pixels[currPos] = black; //...Pixel schwarz färben
      }
    }
  }

  updatePixels();
  //Mittelpunkte des roten und des blauen Kreises
  rot_xPos = (rotxmin + rotxmax)/2;
  rot_yPos = (rotymin + rotymax)/2;
  blau_xPos = (blauxmin + blauxmax)/2;
  blau_yPos = (blauymin+blauymax)/2;
  //Mittelpunkte in Schwarz einzeichnen
  strokeWeight(5);
  stroke(0);
  point(rot_xPos, rot_yPos);
  point(blau_xPos, blau_yPos);
  //rot_xPos = 0;
  //rot_yPos = 0;
  //blau_xPos = 0;
  //blau_yPos = 0;
}

boolean bereichTesten(int seite_a, int seite_b) 
{
  for ( int i = x_1; i < seite_a + x_1; i++) { //x-Achse des Kästchens ablaufen
    for (int j = y_1; j < seite_b + y_1; j++) { //y-Achse des Kästchen ablaufens
      int testFarbe = get(i, j);
      float testHelligkeit = brightness(testFarbe);
      if (testHelligkeit < threshold) { //Falls Helligkeit am Punkt kleiner als der Grenzwert ist...
        return true; //...ist Schwarz vorhanden
      }
      //print(j);
      //print(" ");
    }
    //println(i);
  }
  return false; //Ansonsten ist kein Schwarz vorhanden
}