float berechneWinkel(float xPos, float yPos) {  // berechnet winkel zwischen richtung des Roboters und gerade Mittelpunkt des Roboters und punkt xPos yPos
  float alphav = arctan(blau_xPos-rot_xPos, (height-blau_yPos)-(height-rot_yPos));
  float alphaz = arctan(xPos-rot_xPos, (height-yPos)-(height-rot_yPos));
  float winkel = alphaz-alphav;

  if (winkel > PI) {
    winkel = winkel - 2*PI;
  } else if (winkel < -PI) {
    winkel = winkel + 2*PI;
  }
  return winkel;
}

float arctan(float deltax, float deltay) { //Berechnung des Arkustangens von 0 bis 360 Grad, damit die Drehrichtung bestimmt werden kann
  if (deltay == 0) {
    if (deltax > 0) {
      return PI;
    } else {
      return -PI;
    }
  } else if (deltay > 0) {
    return atan(deltax/deltay);
  } else {
    return atan(deltax/deltay) + PI;
  }
}

void roboterDrehen(float winkel) 
{
  //gewünschte Radumdrehungen des Roboters berechnen
  float strecke = (winkel*robumfang) / (2*PI);
  float umdrehungen = strecke / radumfang;
  //Signal an Roboter schicken
  if (winkel < 0) //nach links drehen
  {
    val = 'l';
    try
    {
      outToServer.writeBytes(val + str(umdrehungen)); //Beispiel: "l3.24"
    }
    catch (Exception e)
    {
      println(e);
    }
  } else if (winkel > 0) //nach rechts drehen
  {
    val = 'r';
    try
    {
      outToServer.writeBytes(val + str(umdrehungen));
    }
    catch (Exception e)
    {
      println(e);
    }
  } else if (winkel == 0) { //nichts tun bzw. stoppen
    val = 's';
    try
    {
      outToServer.write(val);
    }
    catch (Exception e)
    {
      println(e);
    }
  }
}

void fahren(float zieldistanz) { //Vorwärts fahren
  //gewünschte Radumdrehungen berechnen
  float punktdistanz = dist(rot_xPos, rot_yPos, blau_xPos, blau_yPos);
  float strecke = (punktabstand/punktdistanz) * zieldistanz;
  float wegumdrehungen = strecke / radumfang;
  //Signal an Roboter schicken
  val = 'v';
  try
  {
    outToServer.writeBytes(val + str(wegumdrehungen));
  }
  catch (Exception e)
  {
    println(e);
  }
  delay(10000);
}

void kaestchenAbfahren() {

  int i = (int ) (b / schwammbreite) + 1;

  fahren(a);
  warten(); //Auf Rückmeldung des Roboters warten

  for (int j = 2; j<i; j++) 
  {
    if (j%2 == 0) 
    {
      roboterDrehen(PI/2);
      warten();
      val = 'v';
      try
      {
        outToServer.writeBytes(val + str(schwammumdrehungen));
      }
      catch (Exception e)
      {
        println(e);
      }
      delay(3000);
      roboterDrehen(PI/2);
      warten();
      fahren(a - 2 * schwammdistanz);
      warten();
    } else {
      println("else");
      roboterDrehen(-PI/2);
      warten();
      val = 'v';
      try
      {
        outToServer.writeBytes(val + str(schwammumdrehungen));
      }
      catch (Exception e)
      {
        println(e);
      }
      delay(3000);
      roboterDrehen(-PI/2);
      warten();
      fahren(a - 2 * schwammdistanz);
      warten();
    }
  }
}

void servo() {
  if (angekommen) //Servo Runter lassen
  {
    val = 'R';
    try
    {
      outToServer.write(val);
    }
    catch (Exception e)
    {
      println(e);
    }
    delay(1000);
  } else { //Servo hochfahren
    val = 'H';
    try
    {
      outToServer.write(val);
    }
    catch (Exception e)
    {
      println(e);
    }
    delay(1000);
  }
}

//empfaengt und speichert Variable vom Input
char antwortArduino()
{
  try
  {
    char input = ' ';
    while (inFromServer.available() != 0)
    {
      input = (char) inFromServer.read();
      return input;
    }
  }
  catch (Exception e)
  {
    println(e);
  }
  return ' ';
}

//wartet bis der Arduino seine Aktion zu Ende ausgefuehrt hat
void warten()
{
  char signal = ' ';
  do {
    signal = antwortArduino();
  } while (signal != 'f');
}